#include "hpscat.h"

int  cpl;
aline   pagebuf[Maxline];

/***********************
   fill up page buffer
    (from input file)
 ***********************/

int
fillpagebuf()       /*  supposed to return 1 when no more pages left  */
{
    char  linebuf[Maxchar];
    int   c, ntabs=0, nlines=0, nchars=0;
    double xpos=0., fw;

    fw = narrow ? (double)fsize/2. : (double)fsize*.6;

    while(1) {
	if(ntabs) {
	    while(ntabs-- > 0) {
		linebuf[nchars++] = ' ';
	        xpos += fw;
	    }
	}
      getnext:
	c = getc(fp);
	if(c==EOF || c=='\n')  {
	    linebuf[nchars] = 0;
	    pagebuf[nlines].linenum = (cont) ?  0 : ++cpl;
	    strcpy(pagebuf[nlines].line, linebuf);
	    nlines++;
	    cont = False;
	    if(c==EOF) {
		if(nchars==0) pagebuf[nlines-1].linenum = -1;
		else pagebuf[nlines].linenum = -1;
		return 1;
	    }
	    if(nlines >= prows)	return 0;
	    xpos = 0.;
	    nchars = 0;
	    continue;
	}
	else if(c=='\t') {
	    int  spc = 8 - ((int)(xpos/fw+.5) % 8);
	    while(spc-- > 0) {
		linebuf[nchars++] = ' ';
		xpos += fw;
		if(xpos > (double)(width-fsize)) {
		    cont = True;
		    ntabs = spc;
		    goto jmp;
		}
	    }
	    continue;
	}
	else if(c<32) goto getnext;
	else if(c=='\\' || c=='(' || c==')')
	   linebuf[nchars++] = '\\';
	linebuf[nchars++] = c;
	if(c>127) {
	    c = getc(fp);
	    linebuf[nchars++] = c;
	    xpos += fsize;
	}
	else xpos += fw;
	if(xpos > (double)(width-fsize)) {
	  jmp:
	    linebuf[nchars] = 0;
	    if(!cont)	pagebuf[nlines].linenum = ++cpl;
	    else	pagebuf[nlines].linenum = 0;
	    strcpy(pagebuf[nlines].line, linebuf);
	    nlines++;
	    cont = True;
	    if(nlines >= prows)	return 0;
	    nchars = 0;
	    xpos = 0.;
	}
    }
}

/***  EOF  ***/
